Accounts Merge - Leetcode 721 - Python

Поділитися
Вставка
  • Опубліковано 6 жов 2024

КОМЕНТАРІ • 35

  • @guilhermezardo7671
    @guilhermezardo7671 Рік тому +65

    Definitely not a medium problem. Should be a hard problem in my opinion...

    • @christendombaffler
      @christendombaffler Рік тому +3

      It's a common Big N interview question, so it's a demoted Hard. Great if you're interested in those companies, awful otherwise, should probably be the final problem in the Union-Find section of the neetcode advanced structures course either way.

  • @krishnasharma657
    @krishnasharma657 4 місяці тому +3

    The neatness of ur code makes u neetcode😊

  • @DavidDLee
    @DavidDLee Рік тому +4

    Interesting solution to use the account index as the nodes being joined in the graph.
    I too used a Union-Find solution but used the email strings as the nodes instead. Using the index, it is pretty trivial to find the name. In my solution, I needed a map from parent -> name.
    Part of the problem is that Union-Find provides as output a non-useful child -> parent tree, which you need to invert into parent -> children.
    The last loop can be done using list comprehension in one line.

  • @technophile_
    @technophile_ Рік тому +3

    I'm just happy that I'm able to at least understand the terminologies used in this video 😅

  • @atreides4911
    @atreides4911 Рік тому +22

    What a coincidence, I was working on this one. Are you doing grind75 problems now??

  • @anishkarthik4309
    @anishkarthik4309 Рік тому +6

    please make solutions for leetcode weekly contests here onwards if possible please, your explanations are very easy and understandable. No one on UA-cam explains better than you.
    So I can learn to solve weekly problems

  • @huzayfasabri9691
    @huzayfasabri9691 Рік тому +6

    Wait what was the time and space complexity?

  • @devenderbhatt421
    @devenderbhatt421 Рік тому +4

    It would be better if u link ur union find explanation video in description itself very hectic to find that in ur old library😢

    • @SamarAshrafii
      @SamarAshrafii 2 місяці тому

      Did you find it? Im looking for it also

  • @subikeshps2289
    @subikeshps2289 6 місяців тому +2

    10:52 I don't understand how union find operations take only constant time? Worst case would be log n isn't it?

    • @vijethkashyap151
      @vijethkashyap151 4 місяці тому +1

      With path compression in the find() operation, it takes O(1) time is what he meant to say I guess, though I am not too sure.

    • @hb-fm1oe
      @hb-fm1oe 3 місяці тому

      its O(1) given the combined optimizations of path compression in find() + the maintaining of a somewhat balanced tree he's doing using the multiple 'if' statements in union()

  • @kyoungjunhan1098
    @kyoungjunhan1098 Рік тому

    Solved this problem like 3 days ago. It was a pain in the butt to get my head around using dfs with two different references.

  • @NeetCodeIO
    @NeetCodeIO  Рік тому +1

    If you're looking for today's daily LC (Design Add and Search Words Data Structure) 👉ua-cam.com/video/BTf05gs_8iU/v-deo.html

  • @sumitsharma6738
    @sumitsharma6738 Рік тому +3

    Bro make videos on leetcode contests too

  • @sethusona7401
    @sethusona7401 Рік тому

    Love to you from India sir ❤️

  • @ayushbhardwaj6783
    @ayushbhardwaj6783 8 місяців тому

    Cann't we just use DFS instead of using disjoint sets. ? Whats the efficiency in using disjoint sets, anyways we have to traverse all connected components.

  • @Daniel-do2mh
    @Daniel-do2mh Рік тому

    Hi man! Move your content and thank you very much for helping us! Would love if u could also make playlists here of "Easy" , "Medium" and "Hard" related to how the leetcode problems solved in the videos are.

  • @pacomarmolejo3492
    @pacomarmolejo3492 Рік тому

    Love your vids bro. Is the time complexity O(NKlogK) where N accounts, K max-emails in an account, as for the DFS solution?

  • @AmolGautam
    @AmolGautam 9 місяців тому

    Thank you

  • @dmitriytereshchenko2032
    @dmitriytereshchenko2032 Рік тому +1

    Thanks for great work!

  • @subhaspaul495
    @subhaspaul495 Рік тому

    please make solutions for leetcode weekly contests

  • @ranjithragul
    @ranjithragul Рік тому

    kind request to solve weekly contest

  • @tsunghan_yu
    @tsunghan_yu Рік тому +2

    bad variable naming

  • @SHAZIALI-gw8bh
    @SHAZIALI-gw8bh 4 місяці тому

    This one should be hard 🤯

  • @gauravdesale47
    @gauravdesale47 Рік тому

    This one of tough af

  • @vidur_7
    @vidur_7 Рік тому

    first

  • @SydneyMadueke
    @SydneyMadueke Рік тому

    mEdiUm...

  • @aydenwu900
    @aydenwu900 10 місяців тому +2

    The path compression of find() in your code is not actually compressing path, here is the one that actually compress:
    def find(self, node):
    # Path Compression
    parentIdx = self.parents[node]
    while parentIdx != self.parents[parentIdx]:
    parentIdx = self.parents[parentIdx]
    self.parents[node] = parentIdx
    return parentIdx

    • @chrisdafa
      @chrisdafa 9 місяців тому +3

      it is compressing path. It's partial path compression. It basically updates every 2nd element to points to its grandparent. So thereby halving the path to the root parent essentially. It's kinda good because it achieves compression but not as aggressively as full path compression, thus the number of write operations is not as many when calling find(), therefore in some cases it can be more efficient when u call find